﻿package cj.changestar {
	
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.NativeMenu; 
    import flash.display.NativeMenuItem; 
    import flash.display.NativeWindow; 
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.SharedObject;
	import flash.system.LoaderContext;
	import flash.utils.Dictionary;
	
	import com.greensock.TweenLite;
	import com.greensock.easing.Quint;
	
	import cj.components.scrollbar.ScrolBar;
	import cj.changestar.events.LoginEvent;
	import cj.changestar.utils.LoadPhp;

	public final class ChangeStar extends Sprite {
		
		private var login:EnterKey;
		private var failed:Failed;
		private var pre:Preloader;
		private var scrollerOne:ScrolBar;
		private var scrollerTwo:ScrolBar;
		private var noChanges:NoChanges;
		private var success:Success;
		
		private var containerOne:Sprite;
		private var containerTwo:Sprite;
		private var holderOne:Sprite;
		private var holderTwo:Sprite;
		private var so:SharedObject;
		private var soWasEmpty:Boolean; 
		private var stored:Dictionary;
		
		private var itemOne:NativeMenuItem;
		private var itemTwo:NativeMenuItem;
		private var itemThree:NativeMenuItem;
		private var itemFour:NativeMenuItem;
		
		public function ChangeStar() {
			
			if(stage == null) {
				addEventListener(Event.ADDED_TO_STAGE, added);
			}
			else {
				added();
			}
			
		}
		
		private function added(event:Event = null):void {
			
			if(event != null) removeEventListener(Event.ADDED_TO_STAGE, added);
			
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			addEventListener(Event.UNLOAD, unloaded);
			addEventListener(Event.REMOVED_FROM_STAGE, unloaded);
			
			var logo:Logo = new Logo();
			logo.mouseEnabled = logo.mouseChildren = false;
			logo.x = logo.y = 15;
			addChild(logo);
			
			so = SharedObject.getLocal("ChangeStar");
			//so.clear();
			
			if(so != null) {
				
				if(so.data.user && so.data.key) {
					
					addPreloader();
					soWasEmpty = false;
					LoadPhp.load(so.data.user, so.data.key, apiLoaded, phpFailed);
					
				}
				
				else {
					
					soWasEmpty = true;
					createLogin();
					
				}
				
			}
			else {
				
				soWasEmpty = true;
				createLogin();
				
			}
			
			createNativeMenu();
			
		}
		
		private function createLogin():void {
			
			login = new EnterKey();
			login.x = 250;
			login.y = 163;
			login.alpha = 0;
			addChild(login);
			
			TweenLite.to(login, 0.75, {alpha: 1, ease: Quint.easeOut});
			
			addEventListener(LoginEvent.API_LOGIN, userSubmit);
			
		}
		
		private function userSubmit(event:LoginEvent):void {
			
			removeEventListener(LoginEvent.API_LOGIN, userSubmit);
			
			if(failed != null) {
				
				TweenLite.killTweensOf(failed, true);
				if(failed != null) TweenLite.to(failed, 0.5, {alpha: 0, ease: Quint.easeOut, onComplete: killFailed});
				
			}
			
			addPreloader();
			LoadPhp.load(event.userName, event.apiKey, apiLoaded, phpFailed);
			
		}
		
		private function addPreloader():void {
			
			pre = new Preloader();
			pre.x = 765;
			pre.y = 29;
			addChild(pre);
			
			addEventListener(Event.ENTER_FRAME, spinPre);
			
		}
		
		private function spinPre(event:Event):void {
			
			pre.rotation += 12;
			
		}
		
		private function killPre():void {
			
			removeEventListener(Event.ENTER_FRAME, spinPre);
			removeChild(pre);
			pre = null;
			
		}
		
		private function killFailed():void {
			
			removeChild(failed);
			failed = null;
			
		}
		
		private function phpFailed() {
			
			if(pre != null) {
			
				TweenLite.killTweensOf(pre, true);
				if(pre != null) TweenLite.to(pre, 0.5, {alpha: 0, ease: Quint.easeOut, onComplete: killPre});
				
			}
			
			failed = new Failed();
			failed.x = 128;
			failed.y = 317;
			failed.alpha = 0;
			failed.mouseEnabled = failed.mouseChildren = false;
			addChild(failed);
			
			TweenLite.to(failed, 0.75, {alpha: 1, ease: Quint.easeOut});
			
			login.addClick();
			addEventListener(LoginEvent.API_LOGIN, userSubmit);
			
		}
		
		private function apiLoaded(files:Dictionary):void {
			
			if(pre != null) {
			
				TweenLite.killTweensOf(pre, true);
				if(pre != null) TweenLite.to(pre, 0.5, {alpha: 0, ease: Quint.easeOut, onComplete: killPre});
				
			}
			
			if(login != null) {
				
				so.data.user = login.user;
				so.data.key = login.key;
				so.flush(); 
				
				removeChild(login);
				login = null;
				
			}
			
			holderTwo = new Sprite();
			containerTwo = new Sprite();
			scrollerTwo = new ScrolBar();
			
			containerTwo.visible = false;
			scrollerTwo.visible = false;
			
			if(!soWasEmpty) {
				
				holderOne = new Sprite();
				containerOne = new Sprite();
				scrollerOne = new ScrolBar();
				
				createList(files, holderOne, containerOne, scrollerOne);
				
				itemOne.enabled = true;
				itemTwo.enabled = true;
				itemThree.enabled = true;
				itemFour.enabled = true;
				
				itemOne.addEventListener(Event.SELECT, select); 
				itemTwo.addEventListener(Event.SELECT, select); 
				itemThree.addEventListener(Event.SELECT, select);
				itemFour.addEventListener(Event.SELECT, select); 
				
			}
			else {
				
				so.data.stored = files;
				so.flush();
				
				success = new Success();
				success.x = 128;
				success.y = 163;
				success.alpha = 0;
				addChild(success);
				
				TweenLite.to(success, 0.75, {alpha: 1, ease: Quint.easeOut});
				
				itemOne.enabled = false;
				itemTwo.enabled = true;
				itemThree.enabled = true;
				itemFour.enabled = true;
				
				itemTwo.addEventListener(Event.SELECT, select); 
				itemThree.addEventListener(Event.SELECT, select);
				itemFour.addEventListener(Event.SELECT, select); 
				
			}
			
			createList(files, holderTwo, containerTwo, scrollerTwo, true);
			
			if(noChanges != null) itemOne.enabled = false;
			
		}
		
		private function createNativeMenu():void {
			
			if(NativeWindow.supportsMenu) { 
			
            	stage.nativeWindow.menu = new NativeMenu(); 
                
				var viewMenu:NativeMenuItem = stage.nativeWindow.menu.addItem(new NativeMenuItem("View"));
				var settingsMenu:NativeMenuItem = stage.nativeWindow.menu.addItem(new NativeMenuItem("Settings"));
				var actionsMenu:NativeMenuItem = stage.nativeWindow.menu.addItem(new NativeMenuItem("Actions"));
				
				var menuOne:NativeMenu = new NativeMenu();  
				var menuTwo:NativeMenu = new NativeMenu();
				var menuThree:NativeMenu = new NativeMenu();  
				 
				itemOne = menuOne.addItem(new NativeMenuItem("Changed Ratings")); 
				itemTwo = menuOne.addItem(new NativeMenuItem("All Files")); 
				itemThree = menuTwo.addItem(new NativeMenuItem("Reset User Settings")); 
				itemFour = menuThree.addItem(new NativeMenuItem("Check for Rating Changes")); 
				
				itemOne.enabled = false;
				itemTwo.enabled = false;
				itemThree.enabled = false;
				itemFour.enabled = false;
				
				viewMenu.submenu = menuOne;
				settingsMenu.submenu = menuTwo;
				actionsMenu.submenu = menuThree;
				
			} 
			
		}
		
		private function select(event:Event):void { 
		
            switch(event.target.label) {
				
				case "All Files":
					
					if(containerOne != null) {
						
						TweenLite.killTweensOf(containerOne);
						containerOne.visible = false;
						
						if(scrollerOne != null) {
							if(this.contains(scrollerOne)) scrollerOne.visible = false;
						}
						
					}
					
					TweenLite.killTweensOf(containerTwo);
					containerTwo.alpha = 0;
					containerTwo.visible = true;
					
					if(scrollerTwo != null) {
						if(this.contains(scrollerTwo)) scrollerTwo.visible = true;
					}
					
					TweenLite.to(containerTwo, 0.75, {alpha: 1, ease: Quint.easeOut});
					
					if(noChanges != null) {
						
						TweenLite.killTweensOf(noChanges);
						noChanges.visible = false;
						
					}
					else if(success != null) {
						
						TweenLite.killTweensOf(success);
						success.visible = false;
						
					}
					
				break;
				
				case "Changed Ratings":
					
					if(noChanges == null && success == null) {
					
						TweenLite.killTweensOf(containerTwo);
						TweenLite.killTweensOf(containerOne);
						
						containerOne.alpha = 0;
						containerTwo.visible = false;
						
						if(scrollerTwo != null) {
							if(this.contains(scrollerTwo)) scrollerTwo.visible = false;
						}
						
						if(noChanges != null) {
							
							TweenLite.killTweensOf(noChanges);
							noChanges.alpha = 0;
							noChanges.visible = true;
							
							TweenLite.to(noChanges, 0.75, {alpha: 1, ease: Quint.easeOut});
							
						}
						else {
							
							if(scrollerOne != null) {
								if(this.contains(scrollerOne)) scrollerOne.visible = true;
							}
							
							containerOne.visible = true;
							TweenLite.to(containerOne, 0.75, {alpha: 1, ease: Quint.easeOut});
							
						}
						
					}
				
				break;
				
				case "Reset User Settings":
				
					flushAndLoad(true);
				
				break;
				
				case "Check for Rating Changes":
				
					flushAndLoad();
				
				break;
				
			}
			
        } 
		
		private function createList(files:Dictionary, holder:Sprite, container:Sprite, scrollBar:ScrolBar, isMain:Boolean = false):Boolean {
			
			if(stored == null) stored = so.data.stored;
			
			var leg:int = stored.length;
			var yy:int = 0;
			
			var item:Sprite;
			var thumb:ThumbLoader;
			var itemText:ItemText;
			var prev:String;
			var st:String = "";
			var finder:*;
			
			var context:LoaderContext = new LoaderContext(true);
			
			if(!isMain) {
				
				for each(var obj:Object in stored) {
					
					finder = files[obj.itemName];
					
					if(finder != undefined) {
					
						if(obj.itemRating != finder.itemRating) {
									
							item = new Sprite();
							item.mouseEnabled = false;
							item.y = yy;
									
							thumb = new ThumbLoader(finder.itemThumb, finder.itemUrl, context);
							prev = obj.itemRating.toString() != "0" ? obj.itemRating : 'Unrated';
									
							st = '<a href="' + finder.itemUrl + '">' + '<b>' + finder.itemName + '</b></a><br />';
							st += 'Previous Rating: ' + prev + '<br />';
							st += 'New Rating: ' + finder.itemRating + '<br /><br />';
									
							itemText = new ItemText();
							itemText.txt.htmlText = st;
							itemText.txt.height = itemText.txt.textHeight + 10;
							itemText.y = thumb.height + 5;
									
							item.addChild(thumb);
							item.addChild(itemText);
									
							holder.addChild(item);
									
							yy += item.height;
									
						}
						
					}
					
				}
				
			}
			else {
				
				for each(var objs:Object in files) {	
					
					item = new Sprite();
					item.mouseEnabled = false;
					item.y = yy;
							
					thumb = new ThumbLoader(objs.itemThumb, objs.itemUrl, context);
						
					prev = objs.itemRating.toString() != "0" ? objs.itemRating : 'Unrated';
					
					st = '<a href="' + objs.itemUrl + '">' + '<b>' + objs.itemName + '</b></a><br />';
					st += 'Rating: ' + prev + '<br /><br />';
							
					itemText = new ItemText();
					itemText.txt.htmlText = st;
					itemText.txt.height = itemText.txt.textHeight + 10;
					itemText.y = thumb.height + 5;
							
					item.addChild(thumb);
					item.addChild(itemText);
							
					holder.addChild(item);
							
					yy += item.height;
					
				}
				
			}
			
			if(st != "") {
				
				container.x = 18;
				container.y = 98;
				container.mouseEnabled = false;
				container.addChild(holder);
				
				if(holder.height > 340) {
					
					var masker:Shape = new Shape();
					holder.mask = masker;
					
					with(masker.graphics) {
						
						beginFill(0);
						drawRect(0, 0, 750, 340);
						endFill();
						
					}
					
					scrollBar.activate(holder.numChildren, 340, holder, 0xCCCCCC, 0xDDDDDD);
					scrollBar.x = 770;
					scrollBar.y = 98;
					
					container.addChild(masker);
					addChild(scrollBar);
					
				}
				
				holder.mouseEnabled = false;
				addChild(container);
				
				so.data.stored = files;
				so.flush();
				
				return true;
				
			}
			else {
				
				if(noChanges != null) {
					
					TweenLite.killTweensOf(noChanges);
					if(this.contains(noChanges)) removeChild(noChanges);
					noChanges = null;
					
				}
				
				noChanges = new NoChanges();
				noChanges.x = 128;
				noChanges.y = 163;
				noChanges.alpha = 0;
				addChild(noChanges);
				
				TweenLite.to(noChanges, 0.75, {alpha: 1, ease: Quint.easeOut});
				
				return false;
				
			}
			
		}
		
		private function flushAndLoad(killLogin:Boolean = false):void {
			
			kill();
			
			if(itemOne != null) {
				
				itemOne.addEventListener(Event.SELECT, select); 
				itemTwo.addEventListener(Event.SELECT, select); 
				itemThree.addEventListener(Event.SELECT, select);
				itemFour.addEventListener(Event.SELECT, select); 
				
				itemOne.enabled = false;
				itemTwo.enabled = false;
				itemThree.enabled = false;
				itemFour.enabled = false;
				
			}
			
			if(killLogin) {
				
				so.clear();
				soWasEmpty = true;
				
				if(login != null) {
				
					TweenLite.killTweensOf(login);
					if(this.contains(login)) removeChild(login);
					login = null;
					
				}
				
				createLogin();
				
			}
			else {
				
				addPreloader();
				soWasEmpty = false;
				LoadPhp.load(so.data.user, so.data.key, apiLoaded, phpFailed);
				
			}
			
		}
		
		private function kill():void {
			
			removeEventListener(Event.ENTER_FRAME, spinPre);
			removeEventListener(LoginEvent.API_LOGIN, userSubmit);
			
			LoadPhp.kill();
			
			if(containerOne != null) {
				
				TweenLite.killTweensOf(containerOne);
				
				while(holderOne.numChildren) {
					holderOne.removeChildAt(0);
				}
				
				while(containerOne.numChildren) {
					containerOne.removeChildAt(0);
				}
				
				if(this.contains(containerOne)) removeChild(containerOne);
				
				if(scrollerOne != null) {
					if(this.contains(scrollerOne)) removeChild(scrollerOne);
					scrollerOne = null;
				}
				
				containerOne = null;
				holderOne = null;
				
			}
			
			if(containerTwo != null) {
				
				TweenLite.killTweensOf(containerTwo);
				
				while(holderTwo.numChildren) {
					holderTwo.removeChildAt(0);
				}
				
				while(containerTwo.numChildren) {
					containerTwo.removeChildAt(0);
				}
				
				if(this.contains(containerTwo)) removeChild(containerTwo);
				
				if(scrollerTwo != null) {
					if(this.contains(scrollerTwo)) removeChild(scrollerTwo);
					scrollerTwo = null;
				}
				
				containerTwo = null;
				holderTwo = null;
				
			}
			
			if(pre != null) {
				
				TweenLite.killTweensOf(pre);
				if(this.contains(pre)) removeChild(pre);
				pre = null;
				
			}
				
			if(failed != null) {
			
				TweenLite.killTweensOf(failed);
				if(this.contains(failed)) removeChild(failed);
				failed = null;
				
			}
			
			if(success != null) {
				
				TweenLite.killTweensOf(success);
				if(this.contains(success)) removeChild(success);
				success = null;
				
			}
			
			if(noChanges != null) {
				
				TweenLite.killTweensOf(noChanges);
				if(this.contains(noChanges)) removeChild(noChanges);
				noChanges = null;
				
			}
			
			stored = null;
			
		}
		
		private function unloaded(event:Event):void {
			
			kill();
			
			removeEventListener(Event.UNLOAD, unloaded);
			removeEventListener(Event.ADDED_TO_STAGE, added);
			removeEventListener(Event.REMOVED_FROM_STAGE, unloaded);
			
			while(this.numChildren) {
				removeChildAt(0);
			}
			
			if(itemOne != null) {
				
				itemOne.removeEventListener(Event.SELECT, select); 
				itemTwo.removeEventListener(Event.SELECT, select); 
				itemThree.removeEventListener(Event.SELECT, select); 
				
				itemOne = null;
				itemTwo = null;
				itemThree = null;
				
			}
			
			so = null;
			
		}

	}
	
}




















