﻿package cj.changestar {
	
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.FocusEvent;
	import flash.events.Event;
	
	import com.greensock.TweenLite;
	import com.greensock.easing.Quint;
	
	import cj.changestar.events.LoginEvent;
	
	public final class EnterKey extends Sprite {
		
		private var userTxt:InputText;
		private var keyTxt:InputText;
		private var btn:SubmitButton;
		
		internal var user:String;
		internal var key:String;
		
		public function EnterKey() {
			
			userTxt = new InputText();
			userTxt.txt.text = "Enter Envato UserName";
			addChild(userTxt);
			
			keyTxt = new InputText();
			keyTxt.y = userTxt.height + 15;
			keyTxt.txt.text = "Enter Envato API Key";
			addChild(keyTxt);
			
			btn = new SubmitButton();
			btn.mouseChildren = false;
			btn.buttonMode = true;
			btn.x = 109;
			btn.y = keyTxt.y + keyTxt.height + 18;
			addChild(btn);
			
			keyTxt.txt.addEventListener(FocusEvent.FOCUS_IN, inFocus, false, 0, true);
			keyTxt.txt.addEventListener(FocusEvent.FOCUS_OUT, outFocus, false, 0, true);
			userTxt.txt.addEventListener(FocusEvent.FOCUS_IN, insFocus, false, 0, true);
			userTxt.txt.addEventListener(FocusEvent.FOCUS_OUT, outsFocus, false, 0, true);
			btn.addEventListener(MouseEvent.ROLL_OVER, btnOver, false, 0, true);
			btn.addEventListener(MouseEvent.ROLL_OUT, btnOut, false, 0, true);
			btn.addEventListener(MouseEvent.CLICK, btnClick, false, 0, true);
			addEventListener(Event.REMOVED_FROM_STAGE, removed, false, 0, true);
			
		}
		
		internal function addClick():void {
			
			keyTxt.text = "Enter Envato API Key";
			userTxt.text = "Enter Envato UserName";
			
			userTxt.enabled = true;
			keyTxt.enabled = true;
			
			btn.buttonMode = true;
			btn.addEventListener(MouseEvent.ROLL_OVER, btnOver, false, 0, true);
			btn.addEventListener(MouseEvent.ROLL_OUT, btnOut, false, 0, true);
			btn.addEventListener(MouseEvent.CLICK, btnClick, false, 0, true);
			
		}
		
		private function btnOver(event:MouseEvent):void {
			
			TweenLite.to(btn, 0.5, {alpha: 0.65, ease: Quint.easeOut});
			
		}
		
		private function btnOut(event:MouseEvent = null):void {
			
			TweenLite.to(btn, 0.5, {alpha: 1, ease: Quint.easeOut});
			
		}
		
		private function btnClick(event:MouseEvent):void {
			
			if(keyTxt.txt.text != "" && keyTxt.txt.text != "Enter Envato API Key" && userTxt.txt.text != "" && userTxt.txt.text != "Enter Envato UserName") {
				
				btn.removeEventListener(MouseEvent.CLICK, btnClick);
				btn.removeEventListener(MouseEvent.ROLL_OVER, btnOver);
				btn.removeEventListener(MouseEvent.ROLL_OUT, btnOut);
				btn.buttonMode = false;
				
				btnOut();
				
				user = userTxt.txt.text;
				key = keyTxt.txt.text;
				
				userTxt.enabled = false;
				keyTxt.enabled = false;
				
				dispatchEvent(new LoginEvent(LoginEvent.API_LOGIN, user, key));
				
			}
			else {
				
				keyTxt.txt.text = "Enter Envato API Key";
				userTxt.txt.text = "Enter Envato UserName";
				
			}
			
		}
		
		private function insFocus(event:FocusEvent):void {
			
			if(userTxt.txt.text == "Enter Envato UserName") {
				
				userTxt.txt.text = "";
				
			}
			
		}
		
		private function outsFocus(event:FocusEvent):void {
			
			if(userTxt.txt.text == "") {
				
				userTxt.txt.text = "Enter Envato UserName";
				
			}
			
		}
		
		private function inFocus(event:FocusEvent):void {
			
			if(keyTxt.txt.text == "Enter Envato API Key") {
				
				keyTxt.txt.text = "";
				
			}
			
		}
		
		private function outFocus(event:FocusEvent):void {
			
			if(keyTxt.txt.text == "") {
				
				keyTxt.txt.text = "Enter Envato API Key";
				
			}
			
		}
		
		private function removed(event:Event):void {
			
			removeEventListener(Event.REMOVED_FROM_STAGE, removed);
			
			keyTxt.txt.removeEventListener(FocusEvent.FOCUS_IN, inFocus);
			keyTxt.txt.removeEventListener(FocusEvent.FOCUS_OUT, outFocus);
			userTxt.txt.removeEventListener(FocusEvent.FOCUS_IN, insFocus);
			userTxt.txt.removeEventListener(FocusEvent.FOCUS_OUT, outsFocus);
			btn.removeEventListener(MouseEvent.ROLL_OVER, btnOver);
			btn.removeEventListener(MouseEvent.ROLL_OUT, btnOut);
			btn.removeEventListener(MouseEvent.CLICK, btnClick);
			
			while(this.numChildren) {
				removeChildAt(0);
			}
			
			userTxt = null;
			keyTxt = null;
			btn = null;
			
		}

	}
	
}
















