﻿package cj.changestar {
	
	import flash.display.Sprite;
	import flash.display.Loader;
	import flash.events.IOErrorEvent;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.system.LoaderContext;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	
	import com.greensock.TweenLite;
	import com.greensock.easing.Quint;
	
	public class ThumbLoader extends Sprite {
		
		private var loader:Loader;
		private var url:String;
		
		public final function ThumbLoader(tUrl:String, iUrl:String, context:LoaderContext) {
			
			this.alpha = 0;
			url = iUrl;
			
			loader = new Loader();
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, catchError, false, 0, true);
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, thumbLoaded, false, 0, true);
			loader.load(new URLRequest(tUrl), context);
			
			with(this.graphics) {
				
				beginFill(0xCCCCCC);
				drawRect(0, 0, 84, 84);
				endFill();
				
			}
			
			addEventListener(Event.REMOVED_FROM_STAGE, removed, false, 0, true);
			
		}
		
		private function catchError(event:IOErrorEvent):void {
			
			event.target.removeEventListener(IOErrorEvent.IO_ERROR, catchError);
			event.target.removeEventListener(Event.COMPLETE, thumbLoaded);
			
			loader = null;
			
		}
		
		private function thumbLoaded(event:Event):void {
			
			event.target.removeEventListener(IOErrorEvent.IO_ERROR, catchError);
			event.target.removeEventListener(Event.COMPLETE, thumbLoaded);
			
			event.target.content.x = event.target.content.y = 2;
			addChild(event.target.content);
			
			this.buttonMode = true;
			addEventListener(MouseEvent.ROLL_OVER, over, false, 0, true);
			addEventListener(MouseEvent.ROLL_OUT, out, false, 0, true);
			addEventListener(MouseEvent.CLICK, clicked, false, 0, true);
			
			TweenLite.to(this, 0.75, {alpha: 1, ease: Quint.easeOut});
			loader = null;
			
		}
		
		private function over(event:MouseEvent):void {
			
			TweenLite.to(this, 0.5, {alpha: 0.65, ease: Quint.easeOut});
			
		}
		
		private function out(event:MouseEvent):void {
			
			TweenLite.to(this, 0.5, {alpha: 1, ease: Quint.easeOut});
			
		}
		
		private function clicked(event:MouseEvent):void {
			
			navigateToURL(new URLRequest(url));
			
		}
		
		private function removed(event:Event):void {
			
			removeEventListener(Event.REMOVED_FROM_STAGE, removed);
			
			if(loader != null) {
				
				loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, catchError);
				loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, thumbLoaded);
				
				try {
					loader.close();
				}
				catch(event:*){};
				
				loader = null;
				
			}
			
			if(this.numChildren) {
				
				TweenLite.killTweensOf(this);
				
				removeEventListener(MouseEvent.ROLL_OVER, over);
				removeEventListener(MouseEvent.ROLL_OUT, out);
				removeEventListener(MouseEvent.CLICK, clicked);
				
				removeChildAt(0);
				
			}
			
			this.graphics.clear();
			
		}

	}
	
}













