﻿package cj.components.scrollbar {
	
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.Event;
	
	import cj.components.scrollbar.events.ScrollArrowEvent;
	
	public final class ScrollArrow extends Sprite {
		
		private var isTop:Boolean;
		
		public function ScrollArrow(top:Boolean = false) {
			
			isTop = top;
			
			this.buttonMode = true;
			addEventListener(MouseEvent.CLICK, clicked, false, 0, true);
			addEventListener(MouseEvent.MOUSE_DOWN, downMouse, false, 0, true);
			addEventListener(Event.REMOVED_FROM_STAGE, removed, false, 0, true);
			
		}
		
		private function clicked(event:MouseEvent):void {

			dispatchEvent(new ScrollArrowEvent(ScrollArrowEvent.ARROW_CLICK, isTop));

		}
		
		private function upMouse(event:Event):void {
			
			removeEventListener(Event.ENTER_FRAME, goEnter);
			removeEventListener(MouseEvent.MOUSE_UP, upMouse);
			stage.removeEventListener(Event.MOUSE_LEAVE, upMouse);
			
		}
		
		private function goEnter(event:Event):void {
			
			dispatchEvent(new ScrollArrowEvent(ScrollArrowEvent.ARROW_CLICK, isTop));
			
		}

		private function downMouse(event:MouseEvent):void {
			
			stage.addEventListener(Event.MOUSE_LEAVE, upMouse, false, 0, true);
			addEventListener(MouseEvent.MOUSE_UP, upMouse, false, 0, true);
			addEventListener(Event.ENTER_FRAME, goEnter, false, 0, true);
			
		}

		internal function removed(event:Event):void {
			
			removeEventListener(Event.REMOVED_FROM_STAGE, removed);
			removeEventListener(MouseEvent.CLICK, clicked);
			removeEventListener(MouseEvent.MOUSE_DOWN, downMouse);
			removeEventListener(Event.ENTER_FRAME, goEnter);
			removeEventListener(MouseEvent.MOUSE_UP, upMouse);
			
			while(this.numChildren) {
				removeChildAt(0);
			}
			
			if(stage != null) {
				stage.removeEventListener(Event.MOUSE_LEAVE, upMouse);
			}
			
		}
		
	}
	
}